import pickle

# generate random fractions
def gen_frac(denom):
    res = [None] * (denom-1)
    for i in range(1,denom):
        res[i-1] = (i,denom)
    res.append((1,1))
    res.insert(0,(0,1))
    return res

with open('lib_frac.pkl', 'rb') as f:
    lib_frac = pickle.load(f)

def gen_frac_all(denom_upperbound):
    if denom_upperbound in lib_frac:
        return lib_frac[denom_upperbound]
    
    if denom_upperbound<=1:
        return [(0,1),(1,1)]
    res = []
    for i in range(2,denom_upperbound+1):
        res += gen_frac(i)
    # order and remove duplicates
    res = list(set(res))
    res.sort(key=lambda x: x[0]/x[1])
    out = []
    for i in range(len(res)):
        if len(out)==0:
            out.append(res[i])
        elif frac_equal(out[-1],res[i]):
            continue
        else:
            out.append(res[i])
    lib_frac[denom_upperbound] = out
    return out

def frac_equal(frac1, frac2):
    if frac1[1] == frac2[1]:
        return abs(frac1[0] - frac2[0]) < 1
    else:
        return frac1[0]*frac2[1] == frac1[1]*frac2[0]

def frac_minus(frac1, frac2):
    return (frac1[0]*frac2[1]-frac1[1]*frac2[0],frac1[1]*frac2[1])

def frac_div(frac1, frac2):
    return (frac1[0]*frac2[1],frac1[1]*frac2[0])



# lib_frac = {}
# import time
# start = time.time()

# for i in range(1,50):
#     lib_frac[i**2] = gen_frac_all(i**2)
#     print(i)
#     print('---------------')
#     end = time.time()
#     print(end - start)
# import pickle 
# with open('lib_frac.pkl', 'wb') as f:
#     pickle.dump(lib_frac, f)
