from generate_frac import *
from valuation import valuation_precise
from matplotlib import pyplot as plt
from config import Symbols
from scipy.stats import bernoulli
import random
from valuation import find_outer_connective
from random import randrange
import numpy as np

def find(s, ch):
    return [i for i, ltr in enumerate(s) if ltr == ch]





def convert_multi(mv, dim):
    idc = find(mv, 'x')
    count = 0
    for i in range(len(idc)):
        idx = idc[i] + count
        n = randrange(dim)+1
        mv = mv[:idx+1] + str(n) + mv[idx+1:]
        count += 1
    return mv

def convert_to_prim_nosimp(mv): #convert an mv consisting of wedge and vee to only and, or, not
    if mv.count('x') <= 1:
        return mv
    outer_connective_index = find_outer_connective(mv)
    if mv[1] == Symbols.NOT:
        outer_connective = mv[outer_connective_index]
        left = mv[3:outer_connective_index]
        right = mv[outer_connective_index+1:-2]
    else:
        left, outer_connective, right =mv[1:outer_connective_index], mv[outer_connective_index], mv[outer_connective_index+1:-1]
    if outer_connective == Symbols.AND:
        left = convert_to_prim_nosimp(left)
        right = convert_to_prim_nosimp(right)
        return f"({left}{Symbols.AND}{right})"
    if outer_connective == Symbols.OR:
        left = convert_to_prim_nosimp(left)
        right = convert_to_prim_nosimp(right)
        return f"({left}{Symbols.OR}{right})"
    if outer_connective == Symbols.WEDGE:
        left = convert_to_prim_nosimp(left)
        right = convert_to_prim_nosimp(right)
        out = f"({Symbols.NOT}(({Symbols.NOT}{left}){Symbols.AND}{right}){Symbols.AND}{right})"
        return out 
    if outer_connective == Symbols.VEE:
        left = convert_to_prim_nosimp(left)
        right = convert_to_prim_nosimp(right)
        out = f"({Symbols.NOT}(({Symbols.NOT}{left}){Symbols.OR}{right}){Symbols.OR}{right})"
        return out



def convert_to_prim(mv): #convert an mv consisting of wedge and vee to only and, or, not
    if mv.count('x') <= 1:
        return mv
    outer_connective_index = find_outer_connective(mv)
    if mv[1] == Symbols.NOT:
        outer_connective = mv[outer_connective_index]
        left = mv[3:outer_connective_index]
        right = mv[outer_connective_index+1:-2]
    else:
        left, outer_connective, right =mv[1:outer_connective_index], mv[outer_connective_index], mv[outer_connective_index+1:-1]
    if outer_connective == Symbols.AND:
        left = convert_to_prim(left)
        right = convert_to_prim(right)
        return f"({left}{Symbols.AND}{right})"
    if outer_connective == Symbols.OR:
        left = convert_to_prim(left)
        right = convert_to_prim(right)
        return f"({left}{Symbols.OR}{right})"
    if outer_connective == Symbols.WEDGE:
        if left == '1' or left == '(1)':
            right = convert_to_prim(right)
            out = right
        elif right == '1' or right=='(1)':
            left = convert_to_prim(left)
            out = left
        else:
            left = convert_to_prim(left)
            right = convert_to_prim(right)
            out = f"({Symbols.NOT}(({Symbols.NOT}{left}){Symbols.AND}{right}){Symbols.AND}{right})"
        return out 
    if outer_connective == Symbols.VEE:
        if left == '0' or left=='(0)':
            right = convert_to_prim(right)
            out = right
        elif right == '0' or right=='(0)':
            left = convert_to_prim(left)
            out = left
        else:
            left = convert_to_prim(left)
            right = convert_to_prim(right)
            out = f"({Symbols.NOT}(({Symbols.NOT}{left}){Symbols.OR}{right}){Symbols.OR}{right})"
        return out
    
class MV:        # class variable shared by all instances
    def __init__(self, mv):
        self.mv = mv
        self.denom_upperbound = mv.count('x') #** 2
        self.x = gen_frac_all(self.denom_upperbound)
        num = np.array([num_k for num_k, denom in self.x])
        denom = np.array([denom_k for num, denom_k in self.x])
        num_y = valuation_precise(mv, num, denom)
        denom_y = denom
        self.y = [(num_y[i], denom_y[i]) for i in range(len(num_y))]
        #self.y = [(valuation_precise(mv, num, denom), denom) for num, denom in self.x]
    def find_break_points(self):
        bkp_idx = [0]
        for i in range(1, len(self.y)-1):
            mid_x, mid_y = self.x[i], self.y[i]
            left_x, left_y = self.x[i-1], self.y[i-1]
            right_x, right_y = self.x[i+1], self.y[i+1]
            right_slope = frac_div(frac_minus(right_y, mid_y),frac_minus(right_x, mid_x))
            left_slope = frac_div(frac_minus(mid_y, left_y),frac_minus(mid_x, left_x))
            if frac_equal(left_slope, right_slope):
                continue
            else:
                bkp_idx.append(i)
        bkp_idx.append(len(self.y)-1)
        self.bkp_idx = bkp_idx
    def plot_mv(self, mark_break_points = False):
        self.find_break_points()
        plt.plot([num/denom for num, denom in self.x], [num/denom for num, denom in self.y])
        if mark_break_points:
           plt.scatter([self.x[idx][0]/self.x[idx][1] for idx in self.bkp_idx], [self.y[idx][0]/self.y[idx][1] for idx in self.bkp_idx], color='red')
        #plt.show()



def random_formula_not_only_or(length, not_frequency):
    if length == 1:
        output = 'x'     
        if bernoulli.rvs(not_frequency):
            output = f"({Symbols.NOT}{output})"
        return output
    left_length = random.randint(1, length-1)
    right_length = length - left_length
    left = random_formula_not(left_length, not_frequency)
    right = random_formula_not(right_length, not_frequency)
    outer_connective = Symbols.OR #random.choice([Symbols.AND, Symbols.OR])
    output = f"({left}{outer_connective}{right})"
    if bernoulli.rvs(not_frequency):
            output = f"({Symbols.NOT}{output})"
    
        ## simplify left and right by the axioms
    if outer_connective == Symbols.AND:
        if f"({Symbols.NOT}{left})" == right or f"({Symbols.NOT}{right})" == left:
            output = '0'
        elif left == '0' or right == '0':
            output = '0'
        elif left == f"{Symbols.NOT}0" or left == f"{Symbols.NOT}0":
            output = right
        elif right == f"{Symbols.NOT}0" or right == f"{Symbols.NOT}0":
            output = left
      
    if outer_connective == Symbols.OR:
        if f"({Symbols.NOT}{left})" == right or f"({Symbols.NOT}{right})" == left:
            output = f"{Symbols.NOT}0"
        elif left == f"{Symbols.NOT}0" or right == f"{Symbols.NOT}0":
            output = f"{Symbols.NOT}0"
        elif left == '0':
            output = right
        elif right == '0':
            output = left
    
    return output



def random_formula_not(length, not_frequency):
    if length == 1:
        output = 'x'     
        if bernoulli.rvs(not_frequency):
            output = f"({Symbols.NOT}{output})"
        return output
    left_length = random.randint(1, length-1)
    right_length = length - left_length
    left = random_formula_not(left_length, not_frequency)
    right = random_formula_not(right_length, not_frequency)
    outer_connective = random.choice([Symbols.AND, Symbols.OR])
    output = f"({left}{outer_connective}{right})"
    if bernoulli.rvs(not_frequency):
            output = f"({Symbols.NOT}{output})"
    
        ## simplify left and right by the axioms
    if outer_connective == Symbols.AND:
        if f"({Symbols.NOT}{left})" == right or f"({Symbols.NOT}{right})" == left:
            output = '0'
        elif left == '0' or right == '0':
            output = '0'
        elif left == f"{Symbols.NOT}0" or left == f"{Symbols.NOT}0":
            output = right
        elif right == f"{Symbols.NOT}0" or right == f"{Symbols.NOT}0":
            output = left
      
    if outer_connective == Symbols.OR:
        if f"({Symbols.NOT}{left})" == right or f"({Symbols.NOT}{right})" == left:
            output = f"{Symbols.NOT}0"
        elif left == f"{Symbols.NOT}0" or right == f"{Symbols.NOT}0":
            output = f"{Symbols.NOT}0"
        elif left == '0':
            output = right
        elif right == '0':
            output = left
    
    return output


def random_formula_min_max(length):
    if length == 1:
        output = 'x'     
        return output
    # outer_connective = random.choice([Symbols.AND, Symbols.OR, Symbols.WEDGE, Symbols.VEE])
    outer_connective = random.choice([Symbols.AND, Symbols.OR, Symbols.VEE])
    left_length = random.randint(1, length-1)
    right_length = length - left_length
    left = random_formula_min_max(left_length)
    right = random_formula_min_max(right_length)
    output = f"({left}{outer_connective}{right})"
    return output
   

def random_formula(length, not_frequency = 0):
    if length == 1:
        output = 'x'     
        if bernoulli.rvs(not_frequency):
            output = f"{Symbols.NOT}{output}"
        return output
    outer_connective = random.choice([Symbols.AND, Symbols.OR])
    left_length = random.randint(1, length-1)
    right_length = length - left_length
    left = random_formula(left_length,not_frequency=0)
    right = random_formula(right_length,not_frequency=0)
    if bernoulli.rvs(not_frequency):
        left = f"{Symbols.NOT}{left}"
    if bernoulli.rvs(not_frequency):
        right = f"{Symbols.NOT}{right}"

    ## simplify left and right by the axioms
    if outer_connective == Symbols.AND:
        if f"{Symbols.NOT}{left}" == right or f"{Symbols.NOT}{right}" == left:
            output = '0'
        elif left == '0' or right == '0':
            output = '0'
        elif left == f"{Symbols.NOT}0" or left == f"{Symbols.NOT}0":
            output = right
        elif right == f"{Symbols.NOT}0" or right == f"{Symbols.NOT}0":
            output = left
        else:
            output = f"({left}{outer_connective}{right})"
    if outer_connective == Symbols.OR:
        if f"{Symbols.NOT}{left}" == right or f"{Symbols.NOT}{right}" == left:
            output = f"{Symbols.NOT}0"
        elif left == '1' or left == f"{Symbols.NOT}0" or right == f"{Symbols.NOT}0" or right == '1':
            output = f"{Symbols.NOT}0"
        elif left == '0':
            output = right
        elif right == '0':
            output = left
        else:
            output = f"({left}{outer_connective}{right})"
    # if bernoulli.rvs(not_frequency):
    #     output = f"{Symbols.NOT}{output}"
    return output
    # if random.choice([True, False]):
    ## randomly decide if add not in front of left and right
    # if random.choice([True, False]):
    #     left = f"¬ ({left})"
    # if random.choice([True, False]):
    #     right = f"¬ ({right})"




def random_formula_not_multidim(length, not_frequency, dim=3):
    mv = random_formula_not(length, not_frequency)
    while mv.count('x') < length:
        mv = random_formula_not(length, not_frequency)
    mv = convert_multi(mv, dim)
    return mv



def compare_mv_equal(mv1, mv2):
    mv1 = MV(mv1)
    mv2 = MV(mv2)
    mv1.find_break_points()
    mv2.find_break_points()
    if len(mv1.bkp_idx) != len(mv2.bkp_idx):
        return False
    for i in range(len(mv1.bkp_idx)):
        if not frac_equal(mv1.y[mv1.bkp_idx[i]], mv2.y[mv2.bkp_idx[i]]) or not frac_equal(mv1.x[mv1.bkp_idx[i]], mv2.x[mv2.bkp_idx[i]]):
            return False
    return True

