'''
this script builds a library of mv, sigma(wx+b)
'''
import pandas as pd
import csv
from config import Symbols
import numpy as np
from nonlinearity import sigma
import json
import pickle
import time

from helper import time24

def sigmaConstruct(w, b):
    if (w,b) in lib:
        return lib[(w,b)]
    if w+b <= 0:
        return f"0"
    if w == 0:
        return f"{sigma(b)}"
    wl = w
    wr = w
    wl -= 1  # wl[idx] -= 1
    wr -= 1  # wr[idx] -= 1
    left = sigmaConstruct(wl, b)
    right = sigmaConstruct(wr, b + 1)
    if right == '0' or right == '¬ (1)':
        return '0'
    if left == '1' or left == '¬ (0)':
        return right
    if right == '1' or right == '¬ (0)':
        if left == '0' or left == '¬ (1)':
            return 'x'
        else:
            return f"({left} {Symbols.OR} x)"

    if left == '0' or left == '¬ (1)':
        if right == '1' or right == '¬ (0)':
            return 'x'
        else:
            return f"(x {Symbols.AND} {right})"
            # return '(' +'x' +str(idx+1) + ' ⊙ ' + str(right)+ ')'
    return f"(({left} {Symbols.OR} x) {Symbols.AND} {right})"


lib = {} #key = [w,b], value = mv
for w in range(1, 10, 1):
    start = time.time()
    for b in range(0, w+1):
        b = -1*b

        if (w,b) in lib:
            continue
        else:
            mv = sigmaConstruct(w,b)
            lib[(w,b)] = mv
    print(f"{w} done")
    end = time.time()
    print(f"{time24(end - start)}\n")

with open('lib.p', 'wb') as fp:
    pickle.dump(lib, fp, protocol=pickle.HIGHEST_PROTOCOL)




with open('lib.p', 'rb') as fp:
    lib2 = pickle.load(fp)
