'''
this script builds a library of mv, sigma(wx+b)
'''
import pandas as pd 
import csv
from config import Symbols
# import numpy as np
from nonlinearity import sigma
import json
import pickle
import time
import math
import matplotlib.pyplot as plt
from helper import time24

from sigmaConstruct import sigmaConstruct_agu

lib = {} #key = [w,b], value = mv
for w in range(1, 33, 1):
    start = time.time()
    for b in range(0, w):
        b = -1*b

        if (w,b) in lib:
            continue
        else:
            mv = sigmaConstruct_agu(w,b)
            lib[(w,b)] = mv
    print(f"{w} done")
    end = time.time()
    print(f"{time24(end - start)}\n")

leng = [0] * len(lib)
limit = [0] * len(lib)
i = 0
for key in lib.keys():
    leng[i] =  lib[key].count('x')
    limit[i] = key[0] ** 2
    i += 1
   
plt.figure(figsize=(8, 6))
plt.plot(range(len(lib)), leng,  color='blue', linewidth=2)
plt.plot(range(len(lib)), limit, color='red', linestyle='--')
plt.show()




with open('lib_aguzzoli.p', 'wb') as fp:
    pickle.dump(lib, fp, protocol=pickle.HIGHEST_PROTOCOL)


with open('lib.p', 'rb') as fp:
    lib = pickle.load(fp)

