import pandas as pd
import numpy as np
import ast 
import matplotlib.pyplot as plt

'''
### sim-1, the hat functions
filename = '2025-02-04hats=[1, 2, 3, 4, 5].csv'
df = pd.read_csv(filename, sep='\t')
df = df.drop(df.columns[0], axis=1)
avg_leng = df.values.tolist()
avg_leng = np.array(avg_leng).transpose()
plt.plot(avg_leng[0], avg_leng[1], label='Schauder hat', marker='D', linewidth=3, markersize=10, linestyle='--')
plt.plot(avg_leng[0], avg_leng[2], label='Hyperplane', marker='o', linewidth=3, markersize=10, linestyle='--')
plt.plot(avg_leng[0], avg_leng[3],  label='NN', marker='s', linewidth=3, markersize=10,color='green')
plt.plot(avg_leng[0][0:4], avg_leng[4][0:4],  label='Shallow NN', marker='D', linewidth=3, markersize=10, linestyle='--', color='red')
plt.yscale('log')
plt.xlabel('$s$', fontsize = 15)
plt.ylabel('length of MV term', fontsize = 15)
plt.xticks(avg_leng[0])
plt.legend(fontsize=15,loc='upper left')
pltname = 'plt1.pdf'
plt.savefig(pltname)
plt.show()
'''


### sim-2, random 1-D without composition
filename = '2025-02-04notfreq=0.5MC=500#comp=0leng=[4, 6, 8, 10, 12, 14, 16, 18].csv'
df = pd.read_csv(filename, sep='\t')
df = df.drop(df.columns[0], axis=1)

avg_leng = df.values.tolist()
avg_leng = np.array(avg_leng)[0:6].transpose()


plt.plot(avg_leng[0][0:6], avg_leng[1], label='Schauder hat', marker='D', linewidth=3, markersize=10, linestyle='--')
plt.plot(avg_leng[0], avg_leng[2], label='Hyperplane', marker='o', linewidth=3, markersize=10, linestyle='--')
plt.plot(avg_leng[0], avg_leng[3],  label='NN', marker='s', linewidth=3, markersize=10,color='green')

plt.xlabel(r'length of $\tau (x)$', fontsize = 15)
plt.ylabel('length of extracted MV term', fontsize = 15)
plt.xticks(avg_leng[0])
plt.legend(fontsize=15,loc='upper left')
pltname = 'plt2.pdf'
plt.savefig(pltname)
plt.show()


plt.plot(avg_leng[0], avg_leng[1], label='Schauder hat', marker='D', linewidth=3, markersize=10, linestyle='--')
plt.plot(avg_leng[0], avg_leng[2], label='Hyperplane', marker='o', linewidth=3, markersize=10, linestyle='--')
plt.plot(avg_leng[0], avg_leng[3],  label='NN', marker='s', linewidth=3, markersize=10,color='green')
plt.plot(avg_leng[0], avg_leng[4],  label='Shallow NN', marker='D', linewidth=3, markersize=10, linestyle='--', color='red')
plt.yscale('log')
plt.xlabel(r'length of $\tau (x)$', fontsize = 15)
plt.ylabel('length of extracted MV term', fontsize = 15)
plt.xticks(avg_leng[0])
plt.legend(fontsize=15,loc='upper left')
pltname = 'plt3.pdf'
plt.savefig(pltname)
plt.show()


### number of breakpoints
filename = '2025-02-04notfreq=0.5MC=500#comp=0leng=[4, 6, 8, 10, 12, 14]bkp.csv'
df = pd.read_csv(filename, sep='\t')
df = df.drop(df.columns[0], axis=1)
bkp = df.values.tolist()
bkp = np.array(bkp).transpose()
leng = [4, 6, 8, 10, 12, 14]

plt.plot(leng, bkp[0], label='number of breakpoints', linewidth=3, markersize=10, linestyle='--')

plt.xlabel('length of sampled MV term', fontsize = 15)
plt.ylabel('average number of breakpoints', fontsize = 15)
plt.xticks(leng)
pltname = 'fig0.pdf'
plt.savefig(pltname)
plt.show()
'''
'''


### sim-3, with composition
run_list = [1,2,3,4,5,6,7,8,9,10]
avg_leng = [None]*len(run_list)
for run in run_list:

    filename ='2025-02-05notfreq=0.5MC=50outer=3comp_times=[1, 2, 3, 4, 5]diff_'+ str(run)+'.csv'  
    df = pd.read_csv(filename, sep='\t')
    df = df.drop(df.columns[0], axis=1)
    temp = df.values.tolist()
    temp = np.array(temp).transpose()
    avg_leng[run-1] = temp

avg_leng=np.array(avg_leng)
avg_leng_prim = np.mean(avg_leng, axis=0)
comp_times = ast.literal_eval(filename.split("3comp_times=")[1].split("diff")[0])
plt.plot(comp_times, avg_leng_prim[1], label='Schauder hat', marker='D', linewidth=3, markersize=10, linestyle='--')
plt.plot(comp_times, avg_leng_prim[2], label='Hyperplane', marker='o', linewidth=3, markersize=10, linestyle='--')
plt.plot(comp_times, avg_leng_prim[3],  label='NN', marker='s', linewidth=3, markersize=10,color='green')
plt.yscale('log')


plt.xlabel('$s$', fontsize = 15)
plt.ylabel('length of extracted MV term', fontsize = 15)
plt.xticks(comp_times)
plt.legend(fontsize=15,loc='upper left')
pltname = 'plt4.pdf'
plt.savefig(pltname)
plt.show()

## sim-4, multi dimensional
filename = '2025-03-03notfreq=0.5MC=500multidim=3leng=[3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14].csv'
df = pd.read_csv(filename, sep='\t')
df = df.drop(df.columns[0], axis=1)

avg_leng = df.values.tolist()
avg_leng = np.array(avg_leng).transpose()

plt.plot(avg_leng[0], avg_leng[1],  label='NN', marker='s', linewidth=3, markersize=10,color='green')
plt.xlabel(r'length of $\tau (x_1,x_2,x_3)$', fontsize = 15)
plt.ylabel('length of extracted MV term', fontsize = 15)
plt.xticks(avg_leng[0])
plt.legend(fontsize=15,loc='upper left')
pltname = 'siim6.pdf'
plt.savefig(pltname)
plt.show()

### experiment 2, random 1-D with composition once

filename = '2025-01-30notfreq=0.5MC=500#comp=1outer=3inner=[2, 3, 4, 5, 6, 7].csv'
df = pd.read_csv(filename, sep='\t')
df = df.drop(df.columns[0], axis=1)

avg_leng = df.values.tolist()
avg_leng = np.array(avg_leng).transpose()

# MC =filename.split("MC=")[1].split("#")[0]
outer_length = int(filename.split("outer=")[1].split("inner")[0])
n_bits_list = filename.split("inner=")[1].split(".")[0]
n_bits_list = ast.literal_eval(n_bits_list)
n_bits_list_total = [k * outer_length for k in n_bits_list]

plt.plot(avg_leng[0], avg_leng[1], label='Schauder hat', marker='D', linewidth=3, markersize=10, linestyle='--')
plt.plot(avg_leng[0], avg_leng[2], label='Hyperplane', marker='o', linewidth=3, markersize=10, linestyle='--')
plt.plot(avg_leng[0], avg_leng[3],  label='NN', marker='s', linewidth=3, markersize=10,color='green')
plt.plot(avg_leng[0], avg_leng[4],  label='Shallow NN', marker='D', linewidth=3, markersize=10, linestyle='--', color='red')
plt.yscale('log')
plt.xlabel('length of sampled MV term', fontsize = 15)
plt.ylabel('length of extracted MV term', fontsize = 15)
plt.xticks(avg_leng[0])
plt.legend(fontsize=15)
pltname = 'plt2.pdf'
plt.savefig(pltname)
plt.show()

plt.plot(avg_leng[0], avg_leng[1], label='Schauder hat', marker='D', linewidth=3, markersize=10, linestyle='--')
plt.plot(avg_leng[0], avg_leng[2], label='Hyperplane', marker='o', linewidth=3, markersize=10, linestyle='--')
plt.plot(avg_leng[0], avg_leng[3],  label='NN', marker='s', linewidth=3, markersize=10,color='green')
#plt.yscale('log')
plt.xlabel('length of sampled MV term', fontsize = 15)
plt.ylabel('length of extracted MV term', fontsize = 15)
plt.xticks(avg_leng[0])
plt.legend(fontsize=15)
pltname = 'plt3.pdf'
plt.savefig(pltname)
plt.show()


### experiment 3, random 1-D with different number of compositions
filename = '2025-02-02notfreq=0.5MC=500outer=2comp_times=[1, 2, 3, 4, 5]1.csv'
filename = '2025-02-02notfreq=0.5MC=100outer=2comp_times=[1, 2, 3, 4, 5]diff.csv'
df = pd.read_csv(filename, sep='\t')
df = df.drop(df.columns[0], axis=1)

avg_leng = df.values.tolist()
avg_leng = np.array(avg_leng).transpose()
outer_length = int(filename.split("outer=")[1].split("comp_times")[0])
comp_times = filename.split("comp_times=")[1].split("diff.")[0]
comp_times = ast.literal_eval(comp_times)
#n_bits_list_total = [k * outer_length for k in n_bits_list]

plt.plot(comp_times, avg_leng[1], label='Schauder hat', marker='D', linewidth=3, markersize=10, linestyle='--')
plt.plot(comp_times, avg_leng[2], label='Hyperplane', marker='o', linewidth=3, markersize=10, linestyle='--')
plt.plot(comp_times, avg_leng[3],  label='NN', marker='s', linewidth=3, markersize=10,color='green')
#plt.plot(avg_leng[0], avg_leng[4],  label='Shallow NN', marker='D', linewidth=3, markersize=10, linestyle='--', color='red')
plt.yscale('log')
plt.xlabel('number of composition', fontsize = 15)
plt.ylabel('length of extracted MV term', fontsize = 15)
plt.xticks(comp_times)
plt.legend(fontsize=15)
pltname = 'plt3.pdf'
plt.savefig(pltname)
plt.show()

plt.plot(avg_leng[0], avg_leng[1], label='Schauder hat', marker='D', linewidth=3, markersize=10, linestyle='--')
plt.plot(avg_leng[0], avg_leng[2], label='Hyperplane', marker='o', linewidth=3, markersize=10, linestyle='--')
plt.plot(avg_leng[0], avg_leng[3],  label='NN', marker='s', linewidth=3, markersize=10,color='green')
#plt.yscale('log')
plt.xlabel('length of sampled MV term', fontsize = 15)
plt.ylabel('length of extracted MV term', fontsize = 15)
plt.xticks(avg_leng[0])
plt.legend(fontsize=15)
pltname = 'plt3.pdf'
plt.savefig(pltname)
plt.show()