from mv import MV
from NN2MV import NN2MV
from hyperplane2MV import hyperplane2MV
from schauderhat2mv import schauderhat2mv
from mv import random_formula, random_formula_min_max, random_formula_not,random_formula_not_only_or, compare_mv_equal
import matplotlib.pyplot as plt
from construct_NN_from_MV import construct_NN_from_MV, construct_shallow_NN_from_MV
import pandas as pd
import datetime
import numpy as np
import time



MC=50
n_bits = 9
not_frequency = 0.5


## test if the schauderhat outputs correct MV terms
for mc in range(MC):
    res_mc = [None]*5
    res_mc_prim = [None]*5
    mv = random_formula_not(n_bits,not_frequency)
    while mv.count('x') < n_bits:# or len(mv.bkp_idx) <=2: 
        mv = random_formula_not(n_bits,not_frequency)
    mv = MV(mv)
    mv.find_break_points()

    ## apply schauderhat 
    xcords = [mv.x[i] for i in mv.bkp_idx]
    ycords = [mv.y[i][0]/mv.y[i][1] for i in mv.bkp_idx]
    sch = schauderhat2mv(xcords, ycords)
    sch.extract(method='aguzzoli')
    print(compare_mv_equal(sch.overallmv, mv.mv))

      
## test if the hyperplane outputs correct MV terms

for mc in range(MC):
    res_mc = [None]*5
    res_mc_prim = [None]*5
    mv = random_formula_not(n_bits,not_frequency)
    while mv.count('x') < n_bits:# or len(mv.bkp_idx) <=2: 
        mv = random_formula_not(n_bits,not_frequency)
    mv = MV(mv)
    mv.find_break_points()


    xcords = [mv.x[i][0]/mv.x[i][1] for i in mv.bkp_idx]
    ycords = [mv.y[i][0]/mv.y[i][1] for i in mv.bkp_idx]
    test = hyperplane2MV(xcords, ycords)
    test.extract(method='aguzzoli')
    print(compare_mv_equal(test.overallMV, mv.mv))

     
    
## test if the NN2MV outputs correct MV terms


for mc in range(MC):
    res_mc = [None]*5
    res_mc_prim = [None]*5
    mv = random_formula_not(n_bits,not_frequency)
    while mv.count('x') < n_bits:# or len(mv.bkp_idx) <=2: 
        mv = random_formula_not(n_bits,not_frequency)
    #mv = '((¬(((¬x)⊙((¬((¬x)⊙(¬((¬x)⊙(¬x)))))⊕x))⊙(¬x)))⊙((¬x)⊙(¬(x⊕x))))'

    mv = MV(mv)
    mv.find_break_points()
    

    Phi = construct_NN_from_MV(mv.mv)
    nn2mv = NN2MV(Phi)
    nn2mv.extract()
    res= nn2mv.MV_terms_composed['Layer' + str(nn2mv.nLayers)][0]
    res = res.replace("x1", "x")

    print(compare_mv_equal(res, mv.mv))


## test shallow NN
for mc in range(MC):
    res_mc = [None]*5
    res_mc_prim = [None]*5
    mv = random_formula_not(n_bits,not_frequency)
    while mv.count('x') < n_bits:# or len(mv.bkp_idx) <=2: 
        mv = random_formula_not(n_bits,not_frequency)
    #mv='(¬((((¬x)⊕((¬x)⊙(¬x)))⊕x)⊙((¬x)⊕(¬((¬((¬(x⊙x))⊕(¬x)))⊕x)))))'

    mv = MV(mv)
    mv.find_break_points()
    

    xcords = [mv.x[idx] for idx in mv.bkp_idx]
    ycords = [mv.y[idx] for idx in mv.bkp_idx]
    Phi_2 = construct_shallow_NN_from_MV(xcords, ycords)
    nn2mv_2 = NN2MV(Phi_2)
    nn2mv_2.extract()
    res = nn2mv_2.MV_terms_composed['Layer' + str(nn2mv_2.nLayers)][0]
    res = res.replace("x1", "x")
    res = res.replace(" ", "")
    print(compare_mv_equal(res, mv.mv))
            
    
