# test the function convert2shallow of the class NN
# generate random relu networks with integer weights and biases, plot the function before and after conversion
from networktools import SymbolicNets
import numpy as np
from NN import NN
import random
from matplotlib import pyplot as plt

random.seed(3)
magnitude = 2

widths = [1, 2, 2, 2, 1] #input-dim 1, output-dim 1, hidden-dim 5, 4, 2
# random.sample(range(0, magnitude), 5)
# network structure 1 -> 5 -> 4 > 2 > 1


layers = []
layers_deep = []
W1 = np.array([random.randint(-1*magnitude, magnitude) for _ in range(2 * 1)]).reshape(2, 1)
b1 = np.array([random.randint(-1*magnitude, magnitude) for _ in range(2)]).reshape(2, 1)
W2 = np.array([random.randint(-1*magnitude, magnitude) for _ in range(1 * 2)]).reshape(1, 2)
b2 = np.array([[0]])

layers.append(SymbolicNets.SymbolicLayer(W1=np.transpose(W1), b1=b1.flatten(), W2=np.transpose(W2), b2=b2.flatten()))
net = SymbolicNets.SymbolicNet(layers)
all_output_neurons = net.range_forward(0, 1)
output = all_output_neurons[0]
plt.plot(output[0], output[1])


layers_deep.append(SymbolicNets.SymbolicLayer(W1=np.transpose(W1), b1=b1.flatten(), W2=np.transpose(W2), b2=b2.flatten()))
layers_deep.append(SymbolicNets.SymbolicLayer(W1=np.transpose(W1), b1=b1.flatten(), W2=np.transpose(W2), b2=b2.flatten()))
layers_deep.append(SymbolicNets.SymbolicLayer(W1=np.transpose(W1), b1=b1.flatten(), W2=np.transpose(W2), b2=b2.flatten()))

net_deep = SymbolicNets.SymbolicNet(layers_deep)
all_output_neurons_deep = net_deep.range_forward(0, 1)
output_deep = all_output_neurons_deep[0]



W1 = np.array([random.randint(-1*magnitude, magnitude) for _ in range(widths[1] * widths[0])]).reshape(widths[1], widths[0])
b1 = np.array([random.randint(-1*magnitude, magnitude) for _ in range(widths[1])]).reshape(widths[1], 1)
W2 = W1
b2=b1
W3 = W1
b3=b1
W4 = np.array([[1, -1]])
b4 = np.array([[0]])
# W2 = np.array([random.randint(-1*magnitude, magnitude) for _ in range(widths[2] * widths[1])]).reshape(widths[2], widths[1])
# b2 = np.array([random.randint(-1*magnitude, magnitude) for _ in range(widths[2])]).reshape(widths[2], 1)
# W3 = np.array([random.randint(-1*magnitude, magnitude) for _ in range(widths[3] * widths[2])]).reshape(widths[3], widths[2])
# b3 = np.array([random.randint(-1*magnitude, magnitude) for _ in range(widths[3])]).reshape(widths[3], 1)
# W4 = np.array([random.randint(-1*magnitude, magnitude) for _ in range(widths[4] * widths[3])]).reshape(widths[4], widths[3])
# b4 = np.array([[0]])

Sigmaw = np.array([[1],
              [-1]])
Sigmab = np.array([[0],
                  [-1]])
Sigmaw2 = np.array([[1, -1]])
Sigmab2 = np.array([[0]])


Phi = NN()
Phi.addLayer(W1, b1)
Phi.addLayer(W2, b2)
Phi.addLayer(W3, b3)
Phi.addLayer(W4, b4)
#Phi.addLayer(Sigmaw, Sigmab)
#Phi.addLayer(Sigmaw2, Sigmab2)

nsample = 5000
x = np.linspace(0, 1, nsample)
y_deep = Phi.feedforward(x.reshape(1, nsample))
plt.plot(x, y_deep.flatten())

Phi.convert2shallow()

nsample = 5000
x = np.linspace(0, 1, nsample)
y_deep = Phi.feedforward(x.reshape(1, nsample))
y_shallow = Phi.feedforward_shallow(x.reshape(1, nsample))
print(np.sum(y_deep == y_shallow) == nsample)


x = 2

plt.plot(x, y_deep.flatten())
plt.plot(x, y_shallow.flatten())
plt.show()

W1 = np.array([[random.sample(range(0, magnitude), 1)[0] for i in range(widths[1])] for j in range(widths[0])])
